;-------------------------------------------------------------------------
; AltKey v3.0
; (C) 1993
; Lasse R. Nielsen
; lrn@daimi.aau.dk
; Compile with TASM (Borland Turbo-Assembler)
;-------------------------------------------------------------------------
.MODEL  compact
.8086

CODE    SEGMENT 'code'
        ASSUME cs:CODE,ds:NOTHING,es:NOTHING
ORG 00h
main:
                        cmp     AH,4FH
                        jne     right_through

                        push    ds
                        push    bx
                        push    ax
                        mov     ah,12h
                        int     16h
                        test    ah,02h
                        je      go_go_go        ;left alt not pressed
left_alt_is_pressed:
                        pop     ax
                        push    ax
                        and     al,7fh
                        sub     al,02h
                        cmp     al,09h
                        ja      go_go_go        ;key outside 1-0 pressed
                        mov     bx,ax
                        xor     bh,bh
                        pop     ax
                        and     al,80h
                        or      al,cs:trans_keys[bx]
                        push    ax
go_go_go:
                        pop     ax
                        pop     bx
                        pop     ds
                        stc
        ASSUME  ds:NOTHING
right_through:
                        jmp dword ptr cs:[ole_vector]
ole_vector              dw ?,?
trans_keys              db 4fh,50h,51h,4bh,4ch,4dh,47h,48h,49h,52h
;numeric keypad makecodes:  1   2   3   4   5   6   7   8   9   0
prog_end:
CODE    ENDS

INIT    SEGMENT 'code'
        ASSUME cs:INIT,ds:_DATA,es:NOTHING
start:
                        mov     ah,30h          ;Only if DOS-VER>=3.0
                        int     21h             ;
                        xchg    al,ah           ;
                        cmp     ax,0300h        ;
                        jae     go_resident     ;
                        mov             ax,INIT
                        mov             ds,ax
                        mov             dx,offset WrongVerText
                        mov             ah,09h
                        int             21h             ;print ascii$-string at ds:dx

                        mov     ax,4c01h        ;  else exit errorlevel 1
                        int     21h             ;
go_resident:
                        mov             ah,62h          ; get psp segment in bx
                        int             21h             ;
                        mov             es,bx
                        mov             ax,es:[2ch]     ; get environment-seg in ax
                        cmp             ax,00h          ;  if !=0 release
                        je              no_release      ;  .
                        mov word ptr    es:[2ch],0      ; dump environment
                        mov             es,ax           ; release memory
                        mov             ah,49h          ; .
                        int             21h             ; .
    ;release environment in hope that it will leave room for resident part
no_release:
                        mov             ax,5800h
                        int             21h
                        mov             cs:mem_allocation_strategy,ax
                        mov             ax,5801h
                        mov             bx,0001h
                        int             21h             ;set memory allocation strategy
                                                        ;to Best Fit


                        mov             ah,48h          ;Allocate block for resident part!
                        mov             bx,(((prog_end-main)+15)/16);ye ole length
                        int             21h             ;.
                        jnc             enough_mem_available
        ;exit, memory unavailable
                        mov             ax,INIT
                        mov             ds,ax
                        mov             dx,offset NoMemText
                        mov             ah,09h
                        int             21h             ;print ascii$-string at ds:dx

                        mov             ax,4c08h
                        int             21h
enough_mem_available:
                        mov             cs:new_seg,ax

                        mov             cx,(offset prog_end); move resident part to new block
                        mov             es,ax
                        mov             ax,CODE
                        mov             ds,ax                             ; .
        ASSUME  ds:NOTHING
                        mov             si,0                              ; .
                        mov             di,0                              ; .
                        cld                                               ; .
                        rep     movsb                                     ; .

                        mov             ax,5801h
                        mov             bx,cs:mem_allocation_strategy
                        int             21h             ;restore strategy
                        

                        mov             ax,3515h        ;get old int15 vector
                        int             21h                     ;

                        mov             ax,cs:new_seg
                        mov             ds,ax
        ASSUME ds:NOTHING

                        mov             ds:[offset ole_vector],bx         ;
                        mov             ds:[offset ole_vector+2],es       ;


                        mov             dx,0                    ;set new vector
                        mov             ax,2515h                ;.(ds:dx)
                        int             21h                     ;.

                        mov             ax,ds          ;changer owner id
                        dec             ax             ;of mcb of resident
                        mov             ds,ax          ;part to It Self!
                        inc             ax
                        mov word ptr    ds:[1],ax      ;
                        mov             cx,End_Name-NameOfProgram
                        mov             bx,0000h
move_name:
                        mov             al,cs:[NameOfProgram+bx]        ;rename resident part
                        mov             ds:[8+bx],al                    ;.
                        inc             bx                              ;.
                        loop            move_name                       ;.

                        mov             ax,INIT
                        mov             ds,ax
                        mov             dx,offset IntroText
                        mov             ah,09h
                        int             21h             ;print ascii$-string at ds:dx

                        mov             ax,4c00h        ;leave well enough alone
                        int             21h             ;
new_seg                 dw      ?
mem_allocation_strategy dw      ?
IntroText       db      'Installed: AltKey v2.0 (C) 1993 by Spot/Triangle 3532.',0dh,0ah,'$'
WrongVerText    db      'Not Installed: AltKey v2.0 - Dos version 3.0 or above required.',0dh,0ah,'$'
NoMemText       db      'Not Installed: AltKey v2.0 - Unable to allocate memory.',0dh,0ah,'$'
NameOfProgram   db      'AltKey',00h
End_Name:
INIT    ENDS
        END start


